﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GridSpawn : MonoBehaviour {

    private float titikX;
    private float titikY;
    private GameObject GameObjectToInstantiate;

    public GameObject GridToShow5x5;
    public GameObject GridToShow6x6;
    public GameObject Kotak5x5;
    public GameObject Kotak6x6;
    public GameObject[,] thisarena;
    public Vector2[] BolckedObject;
    public float coordinatX; // mulai Spawn kotak sumbuX
    public float coordinatY; // mulai spawn kotak sumbuY
    public int BanyakKotak;
    public float JarakX;
    public float JarakY;
    public bool Type;
    // Use this for initialization

    void Start () {
        InitGrid(Type,0);
	}

    public void InitGrid(bool type = true, int level = 0)
    {
        if (type)
        {
            GameObjectToInstantiate = Kotak5x5; BanyakKotak = 5;
            GridToShow5x5.SetActive(true);
            GridToShow6x6.SetActive(false);
            coordinatX = -1.15f;coordinatY = 1.78f;
            JarakX = 1.3f; JarakY = -1.3f;
        }
        else
        {
            if (level == 1)
            {
                BolckedObject = new Vector2[6];
                BolckedObject[0] = new Vector2(4, 0);
                BolckedObject[1] = new Vector2(1, 1);
                BolckedObject[2] = new Vector2(3, 2);
                BolckedObject[3] = new Vector2(2, 3);
                BolckedObject[4] = new Vector2(4, 5);
                BolckedObject[5] = new Vector2(5, 2);
            }
            else if (level == 2)
            {
                BolckedObject = new Vector2[8];
                BolckedObject[0] = new Vector2(5, 0);
                BolckedObject[1] = new Vector2(0, 1);
                BolckedObject[2] = new Vector2(2, 1);
                BolckedObject[3] = new Vector2(0, 4);
                BolckedObject[4] = new Vector2(1, 3);
                BolckedObject[5] = new Vector2(3, 3);
                BolckedObject[6] = new Vector2(2, 4);
                BolckedObject[7] = new Vector2(3, 5);
            }

            GameObjectToInstantiate = Kotak6x6; BanyakKotak = 6;
            GridToShow6x6.SetActive(true);
            GridToShow5x5.SetActive(false);
            coordinatX = -1.28f;coordinatY = 1.82f;
            JarakX = 1.12f; JarakY = -1.1f;
        }

        foreach (Transform v in gameObject.transform)
        {
            Destroy(v.gameObject);
        }
        titikX = coordinatX;
        titikY = coordinatY;
        thisarena = new GameObject[BanyakKotak, BanyakKotak];
        for (int i = 0; i < BanyakKotak; i++)
        {
            for (int j = 0; j < BanyakKotak; j++)
            {
                GameObject g = Instantiate(GameObjectToInstantiate, new Vector2(titikX, titikY), Quaternion.identity, gameObject.transform) as GameObject;

                if (i == 0 && j == 0)//start player
                {
                    Dictionary<string, string> dir = new Dictionary<string, string>();
                    dir.Add("bawah", "bawah");

                    g.GetComponent<SpriteRenderer>().color = Color.magenta;
                    g.GetComponent<unclickedGrid>().CanClick = false;
                    g.GetComponent<unclickedGrid>().canWalk = true;
                    g.GetComponent<unclickedGrid>().hascolor = true;
                    g.GetComponent<unclickedGrid>().Direction = dir;
                }
                else if (i == BanyakKotak-1 && j == BanyakKotak-1)//stopplayer
                {
                    Dictionary<string, string> dir = new Dictionary<string, string>();
                    dir.Add("bawah", "bawah");
                    g.GetComponent<SpriteRenderer>().color = Color.yellow;
                    g.GetComponent<unclickedGrid>().CanClick = false;
                    g.GetComponent<unclickedGrid>().canWalk = true;
                    g.GetComponent<unclickedGrid>().hascolor = true;
                    g.GetComponent<unclickedGrid>().Direction = dir;
                }
                else
                {
                    g.GetComponent<SpriteRenderer>().color = Color.white;
                    g.GetComponent<unclickedGrid>().CanClick = true;
                    g.GetComponent<unclickedGrid>().canWalk = true;
                }
                g.GetComponent<unclickedGrid>().positionX = i;
                g.GetComponent<unclickedGrid>().positionY = j;

                thisarena[i,j] = g;//mengisi g kedalam array
                titikX = titikX + JarakX;
            }
            titikX = coordinatX;
            titikY = titikY + JarakY;
        }

        foreach (var vex2 in BolckedObject)
        {
            
            thisarena[int.Parse(vex2.x+""),int.Parse(vex2.y+"")].GetComponent<SpriteRenderer>().color = Color.black;
            thisarena[int.Parse(vex2.x + ""), int.Parse(vex2.y + "")].GetComponent<unclickedGrid>().CanClick = false;
            thisarena[int.Parse(vex2.x + ""), int.Parse(vex2.y + "")].GetComponent<unclickedGrid>().canWalk = false;
            thisarena[int.Parse(vex2.x + ""), int.Parse(vex2.y + "")].GetComponent<unclickedGrid>().hascolor = true;
        }
        
        //for (int i = 0; i < 5; i++)
        //{
        //    for (int j = 0; j < 5; j++)
        //    {
        //        Debug.Log(thisarena[i,j].GetComponent<unclickedGrid>().positionX + ","+ thisarena[i, j].GetComponent<unclickedGrid>().positionY); 
        //    }
        //}
    }
}
