﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
public class MainMenu : MonoBehaviour {
    public SoundSystem SS;
    public AudioSource Beep;
    public AudioClip BigBoom;
    private void Start()
    {
        Destroy(GameObject.Find("EndingCanvas"));
    }
    public void StartGame()
    {
        SS.BeepMainMenu();
        SceneManager.LoadScene(1);
    }
    public void ExitGame()
    {
        SS.BeepMainMenu();
        Application.Quit();
    }
    public void ToGame()
    {
        SceneManager.LoadScene(2);
    }
    public void ChangeSound()
    {
        Beep.clip = BigBoom;
        Beep.Play();
    }
}
