﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SoundSystem : MonoBehaviour {
    public AudioSource Beep;
    public AudioSource backgroundSound;

    public AudioClip snap;
    public AudioClip GameOverSound;
    public AudioClip WinSound;

    public AudioClip Ending1;
    public AudioClip Ending2;
    public AudioClip Ending3;
    static float waktu;
    // Use this for initialization
    private void Start()
    {
        DontDestroyOnLoad(this.gameObject);
    }
    public void BeepMainMenu()
    {
        waktu = Beep.time;
        Debug.Log(waktu);
    }
    public void PlayOnClickComponent()
    {
        Beep.clip = snap;
        Beep.Play();
    }
    public void PlayGameOverSound()
    {
        Beep.clip = GameOverSound;
        Beep.Play();
    }
    public void PlayWinSound()
    {
        Beep.clip = WinSound;
        Beep.Play();
    }
    public void PlayIntroEndingSound()
    {
        Beep.clip = Ending2;
        Beep.Play();
    }
    public void PlayIntroEnding2()
    {
        Beep.clip = Ending1;
        Beep.Play();
    }
    public void PlayIntroEnding3()
    {
        Beep.clip = Ending3;
        Beep.Play();
    }
}
